import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class Blackjack {
    public NSButton bt_hit;
    public NSButton bt_stand;
    public NSButton bt_start;
    public GameView parent_view;
	public GameView child_view;
	public NSTextField result_msg;

	private Card stack;
	private Child child;
	private Parent parent;

	void applicationDidFinishLaunching(NSNotification aNotification) {
		stack  = new Card(0);
		child  = new Child(stack);
		parent = new Parent(stack);

		gameInit();
	}

	void gameInit() {
		bt_start.setEnabled(true);
		bt_hit.setEnabled(false);
		bt_stand.setEnabled(false);

		child.setButton(bt_stand, bt_hit);
		child.setView(child_view);
		parent.setView(parent_view);

		child.setParent(parent);
		parent.setClass(child, this);	
	}
	
	void gameResult() {
		int p_num = parent.totalScore();
		int c_num = child.totalScore();
		int r=1; // 1:Ƥξ2:Ҥξ
        String win_name = "";
        
        if(p_num <= 21 || c_num <= 21) {
            if(c_num > 21)          {r = 1;}
            else if(p_num > 21)     {r = 2;}
            else if(p_num >= c_num) {r = 1;}
            else if(p_num <  c_num) {r = 2;}
        }
        
        if(r==1) {
            win_name = "Dealer Win..";
        } else {
            win_name = "You Win!!";
        }  

		result_msg.setStringValue(win_name);
		bt_start.setEnabled(true);
		bt_start.setTitle("Replay?");
	}
	
	public void start(Object sender) {
		result_msg.setStringValue("");

		stack.reset();
		parent.backCard();
		child.backCard();

		parent.pullCard();
		child.pullCard();
		parent.pullCard();
		child.pullCard();
		bt_start.setEnabled(false);
		bt_start.setTitle("Playing");
		parent.turn1();
	}
}